/**
 ****************************************************************************************************
 * @file        lcd.h
 * @author      ԭŶ(ALIENTEK)
 * @version     V1.2
 * @date        2023-05-31
 * @brief       2.8/3.5/4.3/7 TFTLCD(MCU) 
 *              ֧ICͺŰ:ILI9341/NT35310/NT35510/SSD1963/ST7789/ST7796/ILI9806 
 *
 * @license     Copyright (c) 2020-2032, ӿƼ޹˾
 ****************************************************************************************************
 * @attention
 *
 * ʵƽ̨:ԭ STM32F103
 * Ƶ:www.yuanzige.com
 * ̳:www.openedv.com
 * ˾ַ:www.alientek.com
 * ַ:openedv.taobao.com
 *
 * ޸˵
 * V1.0 20200421
 * һη
 * V1.1 20200514
 * 1, ST7789 IC֧
 * 2, 򻯲ִ, ⳤж
 * V1.2 20230531
 * 1, ST7796ILI9806 IC֧
 *
 ****************************************************************************************************
 */

#ifndef __LCD_H
#define __LCD_H

#include "stdlib.h"
#include "./SYSTEM/sys/sys.h"


/******************************************************************************************/
/* LCD RST/WR/RD/BL/CS/RS   
 * LCD_D0~D15,̫,Ͳﶨ,ֱlcd_init޸.ֲʱ,˸
 * 6IO, ølcd_initD0~D15ڵIO.
 */

/* RESET ϵͳλŹ ﲻö RESET */
//#define LCD_RST_GPIO_PORT               GPIOx
//#define LCD_RST_GPIO_PIN                SYS_GPIO_PINx
//#define LCD_RST_GPIO_CLK_ENABLE()       do{ __HAL_RCC_GPIOx_CLK_ENABLE(); }while(0)   /* IOʱʹ */

#define LCD_WR_GPIO_PORT                GPIOD
#define LCD_WR_GPIO_PIN                 GPIO_PIN_5
#define LCD_WR_GPIO_CLK_ENABLE()        do{ __HAL_RCC_GPIOD_CLK_ENABLE(); }while(0)   /* IOʱʹ */

#define LCD_RD_GPIO_PORT                GPIOD
#define LCD_RD_GPIO_PIN                 GPIO_PIN_4
#define LCD_RD_GPIO_CLK_ENABLE()        do{ __HAL_RCC_GPIOD_CLK_ENABLE(); }while(0)   /* IOʱʹ */

#define LCD_BL_GPIO_PORT                GPIOB
#define LCD_BL_GPIO_PIN                 GPIO_PIN_0
#define LCD_BL_GPIO_CLK_ENABLE()        do{ __HAL_RCC_GPIOB_CLK_ENABLE(); }while(0)   /* IOʱʹ */

/* LCD_CS(ҪLCD_FSMC_NEXȷIO)  LCD_RS(ҪLCD_FSMC_AXȷIO)   */
#define LCD_CS_GPIO_PORT                GPIOG
#define LCD_CS_GPIO_PIN                 GPIO_PIN_12
#define LCD_CS_GPIO_CLK_ENABLE()        do{ __HAL_RCC_GPIOG_CLK_ENABLE(); }while(0)   /* IOʱʹ */

#define LCD_RS_GPIO_PORT                GPIOG
#define LCD_RS_GPIO_PIN                 GPIO_PIN_0
#define LCD_RS_GPIO_CLK_ENABLE()        do{ __HAL_RCC_GPIOG_CLK_ENABLE(); }while(0)   /* IOʱʹ */

/* FSMCز  
 * ע: ĬͨFSMC1LCD, 14Ƭѡ: FSMC_NE1~4
 *
 * ޸LCD_FSMC_NEX, ӦLCD_CS_GPIOҲø
 * ޸LCD_FSMC_AX , ӦLCD_RS_GPIOҲø
 */
#define LCD_FSMC_NEX         4              /* ʹFSMC_NE4LCD_CS,ȡֵΧֻ: 1~4 */
#define LCD_FSMC_AX          10             /* ʹFSMC_A10LCD_RS,ȡֵΧ: 0 ~ 25 */

#define LCD_FSMC_BCRX        FSMC_Bank1->BTCR[(LCD_FSMC_NEX - 1) * 2]       /* BCRĴ,LCD_FSMC_NEXԶ */
#define LCD_FSMC_BTRX        FSMC_Bank1->BTCR[(LCD_FSMC_NEX - 1) * 2 + 1]   /* BTRĴ,LCD_FSMC_NEXԶ */
#define LCD_FSMC_BWTRX       FSMC_Bank1E->BWTR[(LCD_FSMC_NEX - 1) * 2]      /* BWTRĴ,LCD_FSMC_NEXԶ */

/******************************************************************************************/

/* LCDҪ */
typedef struct
{
    uint16_t width;     /* LCD  */
    uint16_t height;    /* LCD ߶ */
    uint16_t id;        /* LCD ID */
    uint8_t dir;        /* ƣ01 */
    uint16_t wramcmd;   /* ʼдgramָ */
    uint16_t setxcmd;   /* xָ */
    uint16_t setycmd;   /* yָ */
} _lcd_dev;

/* LCD */
extern _lcd_dev lcddev; /* LCDҪ */

/* LCDĻɫͱɫ */
extern uint32_t  g_point_color;     /* ĬϺɫ */
extern uint32_t  g_back_color;      /* ɫ.ĬΪɫ */

/* LCD */
#define LCD_BL(x)   do{ x ? \
                      HAL_GPIO_WritePin(LCD_BL_GPIO_PORT, LCD_BL_GPIO_PIN, GPIO_PIN_SET) : \
                      HAL_GPIO_WritePin(LCD_BL_GPIO_PORT, LCD_BL_GPIO_PIN, GPIO_PIN_RESET); \
                     }while(0)

/* LCDַṹ */
typedef struct
{
    volatile uint16_t LCD_REG;
    volatile uint16_t LCD_RAM;
} LCD_TypeDef;


/* LCD_BASEϸ㷽:
 * һʹFSMCĿ1(BANK1)TFTLCDҺ(MCU), 1ַΧܴСΪ256MB,ֳ4:
 * 洢1(FSMC_NE1)ַΧ: 0X6000 0000 ~ 0X63FF FFFF
 * 洢2(FSMC_NE2)ַΧ: 0X6400 0000 ~ 0X67FF FFFF
 * 洢3(FSMC_NE3)ַΧ: 0X6800 0000 ~ 0X6BFF FFFF
 * 洢4(FSMC_NE4)ַΧ: 0X6C00 0000 ~ 0X6FFF FFFF
 *
 * ҪӲӷʽѡʵƬѡ(LCD_CS)͵ַ(LCD_RS)
 * սF103ʹFSMC_NE4LCD_CS, FSMC_A10LCD_RS ,16λ,㷽:
 * FSMC_NE4ĻַΪ: 0X6C00 0000;     NExĻַΪ(x=1/2/3/4): 0X6000 0000 + (0X400 0000 * (x - 1))
 * FSMC_A10Ӧֵַ: 2^10 * 2 = 0X800;    FSMC_AyӦĵַΪ(y = 0 ~ 25): 2^y * 2
 *
 * LCD->LCD_REG,ӦLCD_RS = 0(LCDĴ); LCD->LCD_RAM,ӦLCD_RS = 1(LCD)
 *  LCD->LCD_RAMĵַΪ:  0X6C00 0000 + 2^10 * 2 = 0X6C00 0800
 *    LCD->LCD_REGĵַΪ LCD->LCD_RAMַ֮.
 * ʹýṹLCD_REG  LCD_RAM(REGǰ,RAMں,Ϊ16λݿ)
 *  ṹĻַ(LCD_BASE) = LCD_RAM - 2 = 0X6C00 0800 -2
 *
 * ͨõļ㹫ʽΪ((ƬѡFSMC_NEx)x=1/2/3/4, (RSӵַFSMC_Ay)y=0~25):
 *          LCD_BASE = (0X6000 0000 + (0X400 0000 * (x - 1))) | (2^y * 2 -2)
 *          Ч(ʹλ)
 *          LCD_BASE = (0X6000 0000 + (0X400 0000 * (x - 1))) | ((1 << y) * 2 -2)
 */
#define LCD_BASE        (uint32_t)((0X60000000 + (0X4000000 * (LCD_FSMC_NEX - 1))) | (((1 << LCD_FSMC_AX) * 2) -2))
#define LCD             ((LCD_TypeDef *) LCD_BASE)

/******************************************************************************************/
/* LCDɨ跽ɫ  */

/* ɨ跽 */
#define L2R_U2D         0           /* ,ϵ */
#define L2R_D2U         1           /* ,µ */
#define R2L_U2D         2           /* ҵ,ϵ */
#define R2L_D2U         3           /* ҵ,µ */

#define U2D_L2R         4           /* ϵ, */
#define U2D_R2L         5           /* ϵ,ҵ */
#define D2U_L2R         6           /* µ, */
#define D2U_R2L         7           /* µ,ҵ */

#define DFT_SCAN_DIR    L2R_U2D     /* Ĭϵɨ跽 */

/* ûɫ */
#define WHITE           0xFFFF      /* ɫ */
#define BLACK           0x0000      /* ɫ */
#define RED             0xF800      /* ɫ */
#define GREEN           0x07E0      /* ɫ */
#define BLUE            0x001F      /* ɫ */ 
#define MAGENTA         0XF81F      /* Ʒɫ/Ϻɫ = BLUE + RED */
#define YELLOW          0XFFE0      /* ɫ = GREEN + RED */
#define CYAN            0X07FF      /* ɫ = GREEN + BLUE */  

/* ǳɫ */
#define BROWN           0XBC40      /* ɫ */
#define BRRED           0XFC07      /* غɫ */
#define GRAY            0X8430      /* ɫ */ 
#define DARKBLUE        0X01CF      /* ɫ */
#define LIGHTBLUE       0X7D7C      /* ǳɫ */ 
#define GRAYBLUE        0X5458      /* ɫ */ 
#define LIGHTGREEN      0X841F      /* ǳɫ */  
#define LGRAY           0XC618      /* ǳɫ(PANNEL),屳ɫ */ 
#define LGRAYBLUE       0XA651      /* ǳɫ(мɫ) */ 
#define LBBLUE          0X2B12      /* ǳɫ(ѡĿķɫ) */ 

/******************************************************************************************/
/* SSD1963ò(һ㲻ø) */

/* LCDֱ */ 
#define SSD_HOR_RESOLUTION      800     /* LCDˮƽֱ */ 
#define SSD_VER_RESOLUTION      480     /* LCDֱֱ */ 

/* LCD */ 
#define SSD_HOR_PULSE_WIDTH     1       /* ˮƽ */ 
#define SSD_HOR_BACK_PORCH      46      /* ˮƽǰ */ 
#define SSD_HOR_FRONT_PORCH     210     /* ˮƽ */ 

#define SSD_VER_PULSE_WIDTH     1       /* ֱ */ 
#define SSD_VER_BACK_PORCH      23      /* ֱǰ */ 
#define SSD_VER_FRONT_PORCH     22      /* ֱǰ */ 

/* ¼Զ */ 
#define SSD_HT          (SSD_HOR_RESOLUTION + SSD_HOR_BACK_PORCH + SSD_HOR_FRONT_PORCH)
#define SSD_HPS         (SSD_HOR_BACK_PORCH)
#define SSD_VT          (SSD_VER_RESOLUTION + SSD_VER_BACK_PORCH + SSD_VER_FRONT_PORCH)
#define SSD_VPS         (SSD_VER_BACK_PORCH)
   
/******************************************************************************************/
/*  */

void lcd_wr_data(volatile uint16_t data);            /* LCDд */
void lcd_wr_regno(volatile uint16_t regno);          /* LCDдĴ/ַ */
void lcd_write_reg(uint16_t regno, uint16_t data);   /* LCDдĴֵ */


void lcd_init(void);                        /* ʼLCD */ 
void lcd_display_on(void);                  /* ʾ */ 
void lcd_display_off(void);                 /* ʾ */
void lcd_scan_dir(uint8_t dir);             /* ɨ跽 */ 
void lcd_display_dir(uint8_t dir);          /* Ļʾ */ 
void lcd_ssd_backlight_set(uint8_t pwm);    /* SSD1963  */ 

void lcd_write_ram_prepare(void);               /* ׼ЩGRAM */ 
void lcd_set_cursor(uint16_t x, uint16_t y);    /* ù */ 
uint32_t lcd_read_point(uint16_t x, uint16_t y);/* (32λɫ,LTDC)  */
void lcd_draw_point(uint16_t x, uint16_t y, uint32_t color);/* (32λɫ,LTDC) */

void lcd_clear(uint16_t color);     /* LCD */
void lcd_fill_circle(uint16_t x, uint16_t y, uint16_t r, uint16_t color);                   /* ʵԲ */
void lcd_draw_circle(uint16_t x0, uint16_t y0, uint8_t r, uint16_t color);                  /* Բ */
void lcd_draw_hline(uint16_t x, uint16_t y, uint16_t len, uint16_t color);                  /* ˮƽ */
void lcd_set_window(uint16_t sx, uint16_t sy, uint16_t width, uint16_t height);             /* ô */
void lcd_fill(uint16_t sx, uint16_t sy, uint16_t ex, uint16_t ey, uint32_t color);          /* ɫ(32λɫ,LTDC) */
void lcd_color_fill(uint16_t sx, uint16_t sy, uint16_t ex, uint16_t ey, uint16_t *color);   /* ɫ */
void lcd_draw_line(uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2, uint16_t color);     /* ֱ */
void lcd_draw_rectangle(uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2, uint16_t color);/*  */


void lcd_show_char(uint16_t x, uint16_t y, char chr, uint8_t size, uint8_t mode, uint16_t color);                       /* ʾһַ */
void lcd_show_num(uint16_t x, uint16_t y, uint32_t num, uint8_t len, uint8_t size, uint16_t color);                     /* ʾ */
void lcd_show_xnum(uint16_t x, uint16_t y, uint32_t num, uint8_t len, uint8_t size, uint8_t mode, uint16_t color);      /* չʾ */
void lcd_show_string(uint16_t x, uint16_t y, uint16_t width, uint16_t height, uint8_t size, char *p, uint16_t color);   /* ʾַ */

#endif

















