/**
 ****************************************************************************************************
 * @file        delay.c
 * @author      ԭŶ(ALIENTEK)
 * @version     V1.0
 * @date        2020-04-17
 * @brief       ʹSysTickͨģʽӳٽй(֧ucosii)
 *              ṩdelay_initʼ delay_usdelay_msʱ
 * @license     Copyright (c) 2020-2032, ӿƼ޹˾
 ****************************************************************************************************
 * @attention
 *
 * ʵƽ̨:ԭ STM32F103
 * Ƶ:www.yuanzige.com
 * ̳:www.openedv.com
 * ˾ַ:www.alientek.com
 * ַ:openedv.taobao.com
 *
 * ޸˵
 * V1.0 20211103
 * һη
 *
 ****************************************************************************************************
 */

#include "./SYSTEM/sys/sys.h"
#include "./SYSTEM/delay/delay.h"


static uint16_t  g_fac_us = 0;      /* usʱ */

/* SYS_SUPPORT_OS,˵Ҫ֧OS(UCOS) */
#if SYS_SUPPORT_OS

/* ӹͷļ ( ucosҪõ) */
#include "includes.h"

/* g_fac_ms, ʾmsʱı, ÿĵms, (ʹosʱ,Ҫõ) */
static uint16_t g_fac_ms = 0;


/*
 *  delay_us/delay_msҪ֧OSʱҪOSصĺ궨ͺ֧
 *  3궨:
 *      delay_osrunning    :ڱʾOSǰǷ,ԾǷʹغ
 *      delay_ostickspersec:ڱʾOS趨ʱӽ,delay_initʼsystick
 *      delay_osintnesting :ڱʾOSжǶ׼,Ϊж治Ե,delay_msʹøò
 *  Ȼ3:
 *      delay_osschedlock  :OS,ֹ
 *      delay_osschedunlock:ڽOS,¿
 *      delay_ostimedly    :OSʱ,.
 *
 *  ̽UCOSIIUCOSIII֧,OS,вοֲ
 */

/* ֧UCOSII */
#ifdef  OS_CRITICAL_METHOD                      /* OS_CRITICAL_METHOD,˵Ҫ֧UCOSII */
#define delay_osrunning     OSRunning           /* OSǷб,0,;1, */
#define delay_ostickspersec OS_TICKS_PER_SEC    /* OSʱӽ,ÿȴ */
#define delay_osintnesting  OSIntNesting        /* жǶ׼,жǶ״ */
#endif

/* ֧UCOSIII */
#ifdef  CPU_CFG_CRITICAL_METHOD                 /* CPU_CFG_CRITICAL_METHOD,˵Ҫ֧UCOSIII */
#define delay_osrunning     OSRunning           /* OSǷб,0,;1, */
#define delay_ostickspersec OSCfg_TickRate_Hz   /* OSʱӽ,ÿȴ */
#define delay_osintnesting  OSIntNestingCtr     /* жǶ׼,жǶ״ */
#endif


/**
 * @brief       usʱʱ,ر(ֹusӳ)
 * @param       
 * @retval      
 */
static void delay_osschedlock(void)
{
#ifdef CPU_CFG_CRITICAL_METHOD  /* ʹUCOSIII */
    OS_ERR err;
    OSSchedLock(&err);          /* UCOSIIIķʽ,ֹȣֹusʱ */
#else                           /* UCOSII */
    OSSchedLock();              /* UCOSIIķʽ,ֹȣֹusʱ */
#endif
}

/**
 * @brief       usʱʱ,ָ
 * @param       
 * @retval      
 */
static void delay_osschedunlock(void)
{
#ifdef CPU_CFG_CRITICAL_METHOD  /* ʹUCOSIII */
    OS_ERR err;
    OSSchedUnlock(&err);        /* UCOSIIIķʽ,ָ */
#else                           /* UCOSII */
    OSSchedUnlock();            /* UCOSIIķʽ,ָ */
#endif
}

/**
 * @brief       usʱʱ,ָ
 * @param       ticks: ʱĽ
 * @retval      
 */
static void delay_ostimedly(uint32_t ticks)
{
#ifdef CPU_CFG_CRITICAL_METHOD
    OS_ERR err;
    OSTimeDly(ticks, OS_OPT_TIME_PERIODIC, &err);   /* UCOSIIIʱģʽ */
#else
    OSTimeDly(ticks);                               /* UCOSIIʱ */
#endif
}

/**
 * @brief       systickжϷ,ʹOSʱõ
 * @param       ticks: ʱĽ
 * @retval      
 */
void SysTick_Handler(void)
{
    if (delay_osrunning == 1)   /* OSʼ,ִĵȴ */
    {
        OSIntEnter();           /* ж */
        OSTimeTick();           /* ucosʱӷ */
        OSIntExit();            /* лж */
    }
    HAL_IncTick();
}
#endif

/**
 * @brief       ʼӳٺ
 * @param       sysclk: ϵͳʱƵ, CPUƵ(HCLK)
 * @retval      
 */
void delay_init(uint16_t sysclk)
{
#if SYS_SUPPORT_OS /* Ҫ֧OS. */
    uint32_t reload;
#endif
    SysTick->CTRL = 0;                                          /* Systick״̬Աһ裬￪жϻرж */
    HAL_SYSTICK_CLKSourceConfig(SYSTICK_CLKSOURCE_HCLK_DIV8);   /* SYSTICKʹںʱԴ8Ƶ,systickļֵֻ2^24 */

    g_fac_us = sysclk / 8;                                      /* ǷʹOS,g_fac_usҪʹ,Ϊ1usĻʱ */
#if SYS_SUPPORT_OS                                              /* Ҫ֧OS. */
    reload = sysclk / 8;                                        /* ÿӵļ λΪM */
    reload *= 1000000 / delay_ostickspersec;                    /* delay_ostickspersec趨ʱ
                                                                 * reloadΪ24λĴ,ֵ:16777216,9M,Լ1.86s
                                                                 */
    g_fac_ms = 1000 / delay_ostickspersec;                      /* OSʱٵλ */
    SysTick->CTRL |= 1 << 1;                                    /* SYSTICKж */
    SysTick->LOAD = reload;                                     /* ÿ1/delay_ostickspersecжһ */
    SysTick->CTRL |= 1 << 0;                                    /* SYSTICK */
#endif
}

#if SYS_SUPPORT_OS  /* Ҫ֧OS, ´ */

/**
 * @brief       ʱnus
 * @param       nus: Ҫʱus.
 * @note        nusȡֵΧ: 0 ~ 477218588(ֵ2^32 / g_fac_us @g_fac_us = 9)
 * @retval      
 */
void delay_us(uint32_t nus)
{
    uint32_t ticks;
    uint32_t told, tnow, tcnt = 0;
    uint32_t reload;
    reload = SysTick->LOAD;     /* LOADֵ */
    ticks = nus * g_fac_us;     /* ҪĽ */
    delay_osschedlock();        /* ֹOSȣֹusʱ */
    told = SysTick->VAL;        /* սʱļֵ */

    while (1)
    {
        tnow = SysTick->VAL;

        if (tnow != told)
        {
            if (tnow < told)
            {
                tcnt += told - tnow;    /* עһSYSTICKһݼļͿ. */
            }
            else
            {
                tcnt += reload - tnow + told;
            }

            told = tnow;

            if (tcnt >= ticks) break;   /* ʱ䳬/Ҫӳٵʱ,˳. */
        }
    }

    delay_osschedunlock();              /* ָOS */
}

/**
 * @brief       ʱnms
 * @param       nms: Ҫʱms (0< nms <= 65535)
 * @retval      
 */
void delay_ms(uint16_t nms)
{
    if (delay_osrunning && delay_osintnesting == 0)     /* OSѾ,Ҳж(ж治) */
    {
        if (nms >= g_fac_ms)                            /* ʱʱOSʱ */
        {
            delay_ostimedly(nms / g_fac_ms);            /* OSʱ */
        }

        nms %= g_fac_ms;                                /* OSѾ޷ṩôСʱ,ͨʽʱ */
    }

    delay_us((uint32_t)(nms * 1000));                   /* ͨʽʱ */
}

#else  /* ʹOSʱ, ´ */

/**
 * @brief       ʱnus
 * @param       nus: Ҫʱus.
 * @note        ע: nusֵ,Ҫ1864135us(ֵ2^24 / g_fac_us  @g_fac_us = 9)
 * @retval      
 */
void delay_us(uint32_t nus)
{
    uint32_t temp;
    SysTick->LOAD = nus * g_fac_us; /* ʱ */
    SysTick->VAL = 0x00;            /* ռ */
    SysTick->CTRL |= 1 << 0 ;       /* ʼ */

    do
    {
        temp = SysTick->CTRL;
    } while ((temp & 0x01) && !(temp & (1 << 16))); /* CTRL.ENABLEλΪ1, ȴʱ䵽 */

    SysTick->CTRL &= ~(1 << 0) ;    /* رSYSTICK */
    SysTick->VAL = 0X00;            /* ռ */
}

/**
 * @brief       ʱnms
 * @param       nms: Ҫʱms (0< nms <= 65535)
 * @retval      
 */
void delay_ms(uint16_t nms)
{
    uint32_t repeat = nms / 1000;   /*  1000,ǿǵгƵӦ,
                                     *  128Mhzʱ, delay_usֻʱ1048576us
                                     */
    uint32_t remain = nms % 1000;

    while (repeat)
    {
        delay_us(1000 * 1000);      /* delay_us ʵ 1000ms ʱ */
        repeat--;
    }

    if (remain)
    {
        delay_us(remain * 1000);    /* delay_us, βʱ(remain ms) */
    }
}

/**
  * @brief HALڲõʱ
           HALʱĬSystickûпSystickжϻᵼµʱ޷˳
  * @param Delay Ҫʱĺ
  * @retval None
  */
void HAL_Delay(uint32_t Delay)
{
     delay_ms(Delay);
}

#endif

































