/**
 ****************************************************************************************************
 * @file        main.c
 * @author      ԭŶ(ALIENTEK)
 * @version     V1.0
 * @date        2022-06-21
 * @brief       ATK-MO395QģUDPͨѶʵ
 * @license     Copyright (c) 2020-2032, ӿƼ޹˾
 ****************************************************************************************************
 * @attention
 *
 * ʵƽ̨:ԭ STM32F103
 * Ƶ:www.yuanzige.com
 * ̳:www.openedv.com
 * ˾ַ:www.alientek.com
 * ַ:openedv.taobao.com
 *
 ****************************************************************************************************
 */

#include "./SYSTEM/sys/sys.h"
#include "./SYSTEM/delay/delay.h"
#include "./SYSTEM/usart/usart.h"
#include "./BSP/LED/led.h"
#include "./BSP/KEY/key.h"
#include "./BSP/LCD/lcd.h"
#include "demo.h"

/**
 * @brief       ʾʵϢ
 * @param       
 * @retval      
 */
void show_mesg(void)
{
    /* LCDʾʵϢ */
    lcd_show_string(10, 10, 220, 32, 32, "STM32", RED);
    lcd_show_string(10, 47, 220, 24, 24, "ATK-MO395Q", RED);
    lcd_show_string(10, 76, 220, 16, 16, "ATOM@ALIENTEK", RED);
    lcd_show_string(10, 97, 200, 16, 16, "KEY0: Send", BLUE);
    
    /* ʵϢ */
    printf("\n");
    printf("********************************\r\n");
    printf("STM32\r\n");
    printf("ATK-MO395Q\r\n");
    printf("ATOM@ALIENTEK\r\n");
    printf("KEY0: Send\r\n");
    printf("********************************\r\n");
    printf("\r\n");
}

int main(void)
{
    HAL_Init();                         /* ʼHAL */
    sys_stm32_clock_init(RCC_PLL_MUL9); /* ʱ, 72Mhz */
    delay_init(72);                     /* ʱʼ */
    usart_init(115200);                 /* ڳʼΪ115200 */
    led_init();                         /* ʼLED */
    key_init();                         /* ʼ */
    lcd_init();                         /* ʼLCD */
    show_mesg();                        /* ʾʵϢ */
    demo_run();                         /* ʾ */
}
